Vue.component('idcard',{
    name:'idcard',
    template:`
    <div> 
        <div>
            <el-button-group>
                <el-button type="primary" v-show="open_visible" @click="onOpenClickHandle">打开设备</el-button>
                <el-button type="primary" v-show="read_visible" @click="onReadClickHandle">读身份证</el-button>
                <el-button type="primary" v-show="close_visible" @click="onCloseClickHandle">关闭设备</el-button>
                <el-button type="primary" @click="onClearClickHandle">清空信息</el-button>
            </el-button-group>
        </div>
        <br/>
        <div style="width: 433px; height: 278px; background: url(assets/IDCard1.png); font-size: 14px">
            <div style="padding-top: 40px; padding-left: 74px; ">
                <label>{{info.name}}</label>
            </div>
            <div style="padding-top: 14px; padding-left: 74px; ">
                <label>{{info.sex}}</label>
                <label style="padding-left: 80px;">{{info.nation}}</label>
            </div>
            <div style="padding-top: 14px; padding-left: 74px; ">
                <label>{{info.birth_year}}</label>
                <label style="padding-left: 34px;">{{info.birth_month}}</label>
                <label style="padding-left: 20px;">{{info.birth_day}}</label>
            </div>
            <div style="padding-top:18px; padding-left:74px;">
                <label>{{info.address}}</label>
            </div>
            <div style="padding-top: 68px; padding-left: 140px; ">
                <label>{{info.idno}}</label>
            </div>
            <el-image :src="info.image" style="top: 190px;left:640px; position: absolute;width:102px;height:126px " />
        </div>
        <br/>
        <div style="width: 433px; height: 278px; background: url(assets/IDCard2.png); font-size: 14px">
            <div style="padding-top: 196px; padding-left: 170px; ">
                <label>{{info.organ}}</label>
            </div>
            <div style="padding-top: 17px; padding-left: 170px; ">
                <label>{{info.begin_date}}-{{info.end_date}}</label>
            </div>
        </div>
    </div>`,
    props:{
        nko_api:null
    },
    data(){
        return {
            close_visible:false,
            read_visible:false,
            open_visible:true,
            info:{
                name:'',
                sex:'',
                nation:'',
                birth_year:'',
                birth_month:'',
                birth_day:'',
                address:'',
                idno:'',
                image:'./assets/head.png',
                organ:'',
                begin_date:'',
                end_date:'' 
            }
        }
    },
    methods:{
        async onOpenClickHandle(){
            let ret = await this.nko_api.OpenDevice();
            if(ret){
                this.$message("打开设备成功");
                this.close_visible = true;
                this.read_visible = true;
                this.open_visible = false;
            }else{
                this.$message("errcode:"+this.nko_api.retData.retcode+",msg:"+this.nko_api.retData.retinfo)
            }
        },
        async onReadClickHandle(){
            let ret = await this.nko_api.GetIDCard();
            if(ret){
                this.info.name = ret.name;
                this.info.sex = ret.sex;
                this.info.nation = ret.nation;
                this.info.birth_year = ret.birth.substring(0,4);
                this.info.birth_month = ret.birth.substring(4,6);
                this.info.birth_day = ret.birth.substring(6,8);
                this.info.address = ret.address;
                this.info.idno = ret.id;
                this.info.organ = ret.organ;
                this.info.begin_date = ret.begin_date;
                this.info.end_date = ret.end_date;
                if(ret.photo_base64!=""){
                  this.info.image = "data:image/jpg;base64,"+ret.photo_base64;
                }
            }else{
                this.$message("errcode:"+this.nko_api.retData.retcode+",msg:"+this.nko_api.retData.retinfo)
            }
        },
        onCloseClickHandle(){
            this.nko_api.CloseDevice();
            this.read_visible = false;
            this.close_visible = false;
            this.open_visible = true;
            this.onClearClickHandle();
        },
        onClearClickHandle(){
            this.info.name = '';
            this.info.sex = '';
            this.info.nation = '';
            this.info.birth_year = '';
            this.info.birth_month = '';
            this.info.birth_day = '';
            this.info.address = '';
            this.info.idno = '';
            this.info.image = './assets/head.png';
            this.info.organ = '';
            this.info.begin_date = '';
            this.info.end_date = '';
        }
    }
}) 