NkoStdApi = function(){
    this.ConnectServer = async function(){
        let wsUri = "ws://127.0.0.1:9600";
        this.websocket = null;
        this.code = "";
        this.IsConnected = false;
        this.retData = {};
        try {
            if (typeof MozWebSocket == 'function')
                WebSocket = MozWebSocket;
            if (this.websocket && this.websocket.readyState == 1)
                this.websocket.close();
            this.websocket = new WebSocket(wsUri);
            var _this = this;
            await new Promise((resolve,reject) => 
            {
                this.websocket.onopen = function(event){
                    _this.IsConnected = true;
                    resolve();
                };
                this.websocket.onclose = function(event){
                    _this.IsConnected = false;
                    reject();
                }
                this.websocket.onerror = function(event){
                    _this.IsConnected = false;
                    reject();
                }
            });
            return this.IsConnected;
        } catch (exception) {
            return ret;
        }
    }
    this.SendMsg = async function(obj){
        let jsonStr = JSON.stringify(obj);
        this.websocket.send(jsonStr);
        var retData = {};
        await new Promise((resolve) =>
        {
            this.websocket.onmessage = function(event){
                retData = JSON.parse(event.data);
                resolve();
            }
        });
        this.retData = retData;
        return retData;
    }
    //打开设备
    this.OpenDevice = async function () {
        this.code = "1001";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
    //关闭设备
    this.CloseDevice = async function () {
        this.code = "1002";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
    //读身份证信息
    this.GetIDCard= async function(){
        this.code = "1003";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.user;
        }
        return false;
    }
    //设置身份证图像保存路径
    this.SetIDPhotoPath = async function (path) {
        this.code = "1004";
        var obj = {};
        obj.code = this.code;
        obj.photo_path = path;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
    //获取控件版本
    this.GetVersion = async function () {
        this.code = "1005";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.version;
        }
        return false;
    }
    //获取扫描仪列表
    this.GetScannerList = async function(){
        this.code = "6001";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.data;
        }
        return false;
    }
    //打开扫描仪
    this.OpenScanner = async function(scanner_name){
        this.code = "6002";
        var obj = {};
        obj.code = this.code;
        obj.scanner_name = scanner_name;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
    //关闭扫描仪
    this.CloseScanner = async function(){
        this.code = "6003";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
    //开始扫描
    this.StartScan = async function(){
        this.code = "6004";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.data;
        }
        return false;
    }
    //获取扫描参数列表
    this.GetScanParamList = async function(){
        this.code = "6005";
        var obj = {};
        obj.code = this.code;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.data;
        }
        return false;
    }
    //获取扫描参数值
    this.GetScanParams = async function(data){
        this.code = "6006";
        var obj = {};
        obj.code = this.code;
        obj.params = data;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return ret.data;
        }
        return false;
    }
    //设置扫描参数值
    this.SetScanParams = async function(data){
        this.code = "6007";
        var obj = {};
        obj.code = this.code;
        obj.params = data;
        let ret = await this.SendMsg(obj);
        if(ret.retcode=="0"){
            return true;
        }
        return false;
    }
}
